package com.dapr.service.controller;

import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Mono;

import java.io.IOException;
import java.util.Map;

@RestController
public class UpdateController extends CommonController {

    @PostMapping(path = "/update")
    public Mono<String> handleMethod(@RequestBody(required = false) byte[] body,
                                     @RequestHeader Map<String, String> headers) {
        return Mono.fromSupplier(() -> {
            try {
                // message="{\"id\": \"%s\", \"content\": \"%s\"}";
                String message = setBody(body, headers);
                update(message);
                return message + " received";
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        });
    }

    private void update(String body) throws IOException {

        // 提取参数
        JSONObject jsonObject = JSONObject.parseObject(body);
        String id = jsonObject.getString("id");
        String content = jsonObject.getString("content");
        System.out.println("Id: " + id);
        System.out.println("Content: " + content);

        //拼接SQL
        String bodyTmpl = "{\"operation\": \"exec\",\"metadata\": {\"sql\": \"UPDATE feedback set content = \\\"%s\\\" where id = \\\"%s\\\" \" }}";
        String sql =String.format(bodyTmpl, content, id);

        // 请求mysql
     //   doMysqlPost(sql);

        // 请求MQ
        sendExecMsg("修改完毕");
    }

}
